<?php
/**
 * 随机显示文章列表
 * 
 * @package RandomArticleList
 * @author df
 * @version 1.0.0
 * @link http://df-blog.cn
 */
class RandomArticleList implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate(){}
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}
    
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form){ 
        $numset = new Typecho_Widget_Helper_Form_Element_Radio('numset',
        array('a'=>'与设置中的"文章列表数目"相同','b'=>'单独设定随机文章列表数目'),
        'a','文章数目选项');
        $form->addInput($numset->multiMode()); 
        $listnum = new Typecho_Widget_Helper_Form_Element_Text('num', NULL, '10', _t('文章数目'));
        $listnum->input->setAttribute('class', 'mini');
        $form->addInput($listnum->addRule('required', _t('必须填写文章列表数目'))
        ->addRule('isInteger', _t('文章数目必须是纯数字')));
    }
    
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}

    /**
     * 插件实现方法
     * 
     * @access public
     * @return void
     */
    public static function parse($format='<li><a href="{permalink}">{title}</a></li>')
    {
        /**获取文章数目设定*/
        $option = Typecho_Widget::widget('Widget_Options')->plugin('RandomArticleList');
        if ($option->numset == 'a'){
            $num = Typecho_Widget::widget('Widget_Options')->postsListSize;
        }else{
            $num = $option->num;
        }
		
        /**获取适配器名称*/
        $db = Typecho_Db::get();
        $adapter = $db->getAdapterName();
        if($adapter =='Pdo_Mysql' | $adapter == 'Mysql'){
            $order=Typecho_Db::SORT_RAND;
        }else{
            $order=Typecho_Db::SORT_RANDOM;
        }
                
        /**获取数据*/
        $result = $db->fetchall($db->select()->from('table.contents')
        ->where('table.contents.status = ?', 'publish')        
        ->where('table.contents.type = ?', 'post')
        ->order($order)
        ->limit($num));        
        
        /** 输出结果 */
        foreach($result as $value){
			$value = Typecho_Widget::widget('Widget_Abstract_Contents')->filter($value);
            echo str_replace(array('{permalink}','{title}'),array($value['permalink'],$value['title']),$format);
        }		
    }
}
